---
image: debian:bullseye

stages:
  - package
  - test
  - deploy

variables:
  # https://github.com/coreos/flannel/releases
  FLANNELD_VERSION: 0.11.0
  FLANNELD_PACKAGE_VERSION: 0.11.0-5

.package_template:
  before_script:
    - find "flanneld" -type d -exec chmod 755 {} \;
    - find "flanneld" -type f -not -name postinst -exec chmod 644 {} \;
    - find "flanneld" -type f -name postinst -exec chmod 755 {} \;
    - find "flanneld" -type f -name preinst -exec chmod 755 {} \;
    - mkdir -p build/ dist/
    - apt-get -qy update > /dev/null
    - apt-get -qyy install wget > /dev/null
  stage: package
  artifacts:
    when: on_success
    expire_in: 1 day
    paths:
      - dist/*

package:amd64:
  extends: .package_template
  script:
    - cd build/
    - wget https://github.com/coreos/flannel/releases/download/v${FLANNELD_VERSION}/flanneld-amd64 2>&1 > /dev/null
    - mkdir -p ../flanneld/usr/bin/
    - cp flanneld-amd64 ../flanneld/usr/bin/flanneld && chmod +x ../flanneld/usr/bin/flanneld
    - cd ..
    - sed -i 's/%%FLANNELD_VERSION%%/'${FLANNELD_PACKAGE_VERSION}'/g' flanneld/DEBIAN/control
    - dpkg-deb -b flanneld/
    - mv flanneld.deb dist/flanneld-amd64.deb

package:arm64:
  extends: .package_template
  script:
    - cd build/
    - wget https://github.com/coreos/flannel/releases/download/v${FLANNELD_VERSION}/flanneld-arm64 2>&1 > /dev/null
    - mkdir -p ../flanneld/usr/bin/
    - cp flanneld-arm64 ../flanneld/usr/bin/flanneld && chmod +x ../flanneld/usr/bin/flanneld
    - cd ..
    - sed -i 's/%%FLANNELD_VERSION%%/'${FLANNELD_PACKAGE_VERSION}'/g' flanneld/DEBIAN/control
    - sed -i 's/amd64/arm64/g' flanneld/DEBIAN/control
    - dpkg-deb -b flanneld/
    - mv flanneld.deb dist/flanneld-arm64.deb

test:
  stage: test
  dependencies:
    - package:amd64
  script:
    - dpkg -i dist/*.deb

deploy:amd64:
  stage: deploy
  dependencies:
    - package:amd64
  before_script:
    - apt-get update -qyy > /dev/null
    - apt-get install curl -qyy > /dev/null
  script:
    - curl -T dist/flanneld-amd64.deb -unerzhul:${BINTRAY_APIKEY} "https://api.bintray.com/content/nerzhul/debian/flanneld/${FLANNELD_PACKAGE_VERSION}/flanneld_${FLANNELD_PACKAGE_VERSION}_amd64.deb;deb_distribution=stretch;deb_component=main;deb_architecture=amd64"

deploy:arm64:
  stage: deploy
  dependencies:
    - package:arm64
  before_script:
    - apt-get update -qyy > /dev/null
    - apt-get install curl -qyy > /dev/null
  script:
    - curl -T dist/flanneld-arm64.deb -unerzhul:${BINTRAY_APIKEY} "https://api.bintray.com/content/nerzhul/debian/flanneld/${FLANNELD_PACKAGE_VERSION}/flanneld_${FLANNELD_PACKAGE_VERSION}_arm64.deb;deb_distribution=stretch;deb_component=main;deb_architecture=arm64"
